package com.saga.thread.down;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import org.apache.commons.lang.StringUtils;
import org.zillion.util.log.LogUtil;

import com.persagy.communication.entity.Packet;
import com.persagy.communication.entity.PacketEntity;
import com.persagy.communication.mina.tcp.server.TCPServerManager;
import com.persagy.communication.mina.udp.server.UDPServerManager;
import com.persagy.communication.util.IServerManager;
import com.saga.entity.PointSet;
import com.saga.entity.Record;
import com.saga.util.Constant;
import com.saga.util.HBaseUtil;

public class CollectThread extends Thread {
	private int port = 0;
	private long getPointList = 0;
	private String ip = null;
	// private List<IServerManager> serverList = new
	// ArrayList<IServerManager>();
	private Map<String, IServerManager> serverList = new HashMap<String, IServerManager>();

	public CollectThread(int port) {
		try {
			try {
				this.ip = Constant.getLocalHostLANAddress().getHostAddress() + ":" + Constant.TypePort.get("Down");

			} catch (Exception e) {
				// TODO Auto-generated catch block
				this.ip = "0.0.0.0" + ":" + Constant.TypePort.get("Down");

				e.printStackTrace();
			}
			this.port = port;
			if (Constant.PortCompress == null || !Constant.PortCompress.containsKey(this.port)) {
				this.serverList.put("UDP", new UDPServerManager("0.0.0.0", this.port, "utf-8", false, 1000));
				this.serverList.put("TCP",
						new TCPServerManager("0.0.0.0", this.port, "utf-8", false, 1000, (byte) '(', (byte) ')'));
			} else {
				if ("true".equalsIgnoreCase(Constant.PortCompress.get(this.port))) {
					// this.serverList.put("UDP", new
					// UDPServerManager("0.0.0.0",
					// this.port, "utf-8", 1000));
					this.serverList.put("UDP", new UDPServerManager("0.0.0.0", this.port, "utf-8", true, 1000));
					this.serverList.put("TCP",
							new TCPServerManager("0.0.0.0", this.port, "utf-8", true, 1000, (byte) '(', (byte) ')'));
				} else {
					// this.serverList.put("UDP", new
					// UDPServerManager("0.0.0.0",
					// this.port, "utf-8", 1000));
					this.serverList.put("UDP", new UDPServerManager("0.0.0.0", this.port, "utf-8", false, 1000));
					this.serverList.put("TCP",
							new TCPServerManager("0.0.0.0", this.port, "utf-8", false, 1000, (byte) '(', (byte) ')'));
				}
			}

		} catch (Exception e) {
			LogUtil.error("CollectThread.Exception: " + e.toString());
			LogUtil.error("CollectThread(" + port + ") failed to excute, exit!");
			System.exit(0);

		}
	}

	public void run() {
		for (Entry<String, IServerManager> server : this.serverList.entrySet()) {
			LogUtil.info("CollectThread(" + this.port + "): " + server.getValue().Name() + " Created ...");
			server.getValue().Start();
			LogUtil.info("CollectThread(" + this.port + "): " + server.getValue().Name() + " Starting ...");
		}
		while (true) {
			try {
				for (Entry<String, IServerManager> server : this.serverList.entrySet()) {
					PacketEntity p = server.getValue().PopRece();
					// LogUtil.info(server.getKey() + " " +
					// "CollectThread.handlePacket begin");
					this.handlePacket(server.getValue(), p);
					// LogUtil.info(server.getKey() + " " +
					// "CollectThread.handlePacket end");
					// LogUtil.info(server.getKey() + " " +
					// "CollectThread.handlePointSet begin");
					this.handlePointSet();
					// LogUtil.info(server.getKey() + " " +
					// "CollectThread.handlePointSet end");
					Thread.sleep(1L);
				}
				// Thread.sleep(3L);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				LogUtil.error("CollectThread.run.Exception: " + e.toString());
			}
		}
	}

	private void handlePointSet() {
		// TODO Auto-generated method stub
		try {
			synchronized (Constant.pointSetList) {
				for (int i = 0; i < Constant.pointSetList.size(); i++) {
					PointSet ps = new PointSet();
					ps = Constant.pointSetList.get(i);
					String address = null;
					if (ps.sendTime == 0) {
						address = Constant.Meter_Collector_Control.get(ps.buildingSign + "-" + ps.meterSign);
						// LogUtil.info("CollectThread.handlePointSet " +
						// ps.buildingSign + " " + ps.meterSign + "." +
						// ps.funcID
						// + " " + address);
						if (address != null) {
							for (Entry<String, IServerManager> server : this.serverList.entrySet()) {
								try {
									// String cmd = StringUtils.join(ps.content,
									// ";").replace("pointset", "senddownset")
									// .replace(ps.buildingSignUP,
									// ps.buildingSign);
									// 1101070037;1;senddownset;;123;1001;11;3.1
									StringBuffer sb = new StringBuffer();

									sb.append(ps.buildingSign).append(";").append(ps.mac).append(";senddownset;;")
											.append(ps.ID).append(";").append(ps.meterSign).append(";")
											.append(ps.funcID).append(";").append(ps.dataSet).append(";");

									String cmd = sb.toString();

									String id = ps.buildingSignUP + "-" + ps.mac + "-" + ps.ID;
									Constant.ps_ID2Status.put(id, "processing:sent");
									HBaseUtil.InsertPointCommunicationLog(Constant.agent,
											Constant.BuildingDB.get(ps.buildingSignUP), ps.buildingSignUP, this.ip,
											ps.mac, ps.meterSign, String.valueOf(ps.funcID), "down", "senddownset",
											String.valueOf(ps.ID), Constant.format(new Date()), "processing:sent");
									server.getValue().AppendToSend(address, new Packet(cmd));
									Constant.collectSend += cmd.length();
									Constant.pointSetList.get(i).sendTime = System.currentTimeMillis();
									HBaseUtil.BatchInsert_Set1(Constant.agent, Constant.BuildingDB.get(ps.buildingSign),
											ps);
									LogUtil.info(server.getValue().Name() + " AppendToSend:" + address + " " + cmd);
									break;
								} catch (Exception e) {
									// TODO Auto-generated catch block
									LogUtil.error("CollectThread.handlePointSet.Exception: " + e.toString());
								}
							}
						}
						if (Constant.pointSetList.get(i).sendTime == 0) {
							Constant.pointSetList.get(i).sendTime = System.currentTimeMillis();
						}
					}
				}
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			LogUtil.error("CollectThread.handlePointSet.Exception: " + e.toString());
		}

	}

	private void handlePacket(IServerManager server, PacketEntity p) {
		// TODO Auto-generated method stub
		try {
			if ((p != null) && (p.content.packetString != null)) {
				// LogUtil.info("handlePacket begin...");
				Constant.collectRec += p.content.packetString.length();
				LogUtil.info(server.Name() + " PopRece:" + p.address + " " + p.content.packetString);
				// LogUtil.info("handlePacket split begin...");
				String[] list = p.content.packetString.replace("(", "").replace(")", "").replace(" ", "").split("&");
				// LogUtil.info("handlePacket split end...");
				StringBuffer sb = new StringBuffer();
				// LogUtil.info("CollectThread Challenge
				// Constant.CollectReportList begin...");

				// LogUtil.info("CollectThread Challenge
				// Constant.CollectReportList get...");
				for (String s : list) {
					// LogUtil.info("handlePacket " + s);
					// LogUtil.info(server.Name() + " PopRece.Split:" +
					// p.address + " " + s);
					String[] rList = s.split(";");
					if ("report".equalsIgnoreCase(rList[2]) && rList.length > 7) {
						// 1101070037;1;report;20010203040506;123;1001;2;11;3.1;12;3.2
						Constant.pointMAC.put(rList[0] + "-" + rList[5], rList[1]);
						Constant.collectCount++;
						Constant.ps_NodeStatus.put(rList[0] + "-" + rList[1], System.currentTimeMillis());
						// LogUtil.info("CollectThread Challenge
						// Constant.CollectReportList begin...");
						// synchronized (Constant.CollectReportList) {
						// LogUtil.info("CollectThread Challenge
						// Constant.CollectReportList get...");
						synchronized (Constant.CollectReportList) {
							if (Constant.BuildingAdds.containsKey(rList[0])) {
								for (String building : Constant.BuildingAdds.get(rList[0])) {
									String newData = s.replace(rList[0], building);
									Constant.CollectReportList.add(newData);
									// LogUtil.info("Constant.CollectReportList
									// add:" + newData);
									// String key = building + "-" + rList[1] +
									// "-" + rList[4];
									// Constant.pointListUp.put(key,
									// System.currentTimeMillis());
								}
							} else {
								Constant.CollectReportList.add(s);
								// LogUtil.info("rList[0]:" + rList[0]);
								// String key = rList[0] + "-" + rList[1] + "-"
								// + rList[4];
								// Constant.pointListUp.put(key,
								// System.currentTimeMillis());
							}
						}
						// }
						// LogUtil.info("CollectThread Challenge
						// Constant.CollectReportList release...");
						// LogUtil.info("handlePacket pushData begin...");
						this.pushData(rList);
						/// LogUtil.info("handlePacket pushData end...");
						// LogUtil.info("handlePacket updateMeterCollector
						/// begin...");
						this.updateMeterCollector(rList[0], rList[5], p.address);
						// LogUtil.info("handlePacket updateMeterCollector
						// end...");
						// if (this.needAck(server)) {
						if (sb.length() > 0) {
							sb.append("&" + rList[0] + ";" + rList[1] + ";" + "reportack" + ";"
									+ Constant.format(new Date()) + ";" + rList[4]);
						} else {
							sb.append(rList[0] + ";" + rList[1] + ";" + "reportack" + ";" + Constant.format(new Date())
									+ ";" + rList[4]);
						}
						// }
					} else if ("reportaddtion".equalsIgnoreCase(rList[2]) && rList.length > 7) {
						Constant.pointMAC.put(rList[0] + "-" + rList[5], rList[1]);
						Constant.collectCount++;
						Constant.ps_NodeStatus.put(rList[0] + "-" + rList[1], System.currentTimeMillis());
						// LogUtil.info("CollectThread Challenge
						// Constant.CollectReportList begin...");
						// synchronized (Constant.CollectReportList) {
						// LogUtil.info("CollectThread Challenge
						// Constant.CollectReportList get...");
						synchronized (Constant.CollectReportList) {
							if (Constant.BuildingAdds.containsKey(rList[0])) {
								for (String building : Constant.BuildingAdds.get(rList[0])) {
									String newData = s.replace(rList[0], building);
									Constant.CollectReportList.add(newData);
									// LogUtil.info("Constant.CollectReportList
									// add:" + newData);
									// String key = building + "-" + rList[1] +
									// "-" + rList[4];
									// Constant.pointListUp.put(key,
									// System.currentTimeMillis());
								}
							} else {
								Constant.CollectReportList.add(s);
								// LogUtil.info("rList[0]:" + rList[0]);
								// String key = rList[0] + "-" + rList[1] + "-"
								// + rList[4];
								// Constant.pointListUp.put(key,
								// System.currentTimeMillis());
							}
						}

						// }
						// LogUtil.info("CollectThread Challenge
						// Constant.CollectReportList release...");
						// LogUtil.info("handlePacket pushData begin...");
						this.pushData2(rList);
						// LogUtil.info("handlePacket pushData end...");
						// LogUtil.info("handlePacket updateMeterCollector
						// begin...");
						this.updateMeterCollector(rList[0], rList[5], p.address);
						// LogUtil.info("handlePacket updateMeterCollector
						// end...");
						// LogUtil.info("handlePacket Ack begin...");
						// if (this.needAck(server)) {
						if (sb.length() > 0) {
							sb.append("&" + rList[0] + ";" + rList[1] + ";" + "reportaddtionack" + ";"
									+ Constant.format(new Date()) + ";" + rList[4]);
						} else {
							sb.append(rList[0] + ";" + rList[1] + ";" + "reportaddtionack" + ";"
									+ Constant.format(new Date()) + ";" + rList[4]);
						}
						// }
						// LogUtil.info("handlePacket Ack end...");
					} else if ("senddownsetack".equalsIgnoreCase(rList[2])) {
						String id = rList[0] + "-" + rList[1] + "-" + rList[4];
						synchronized (Constant.ps_ID2Status) {
							Constant.ps_ID2Status.put(id, "processing:finish:" + rList[7]);
						}
						this.updatePointSet(rList);
						// 1101070037;1;senddownsetack;20010203040506;123;1001;11;success
						String MAC = rList[1];

						if (Constant.pointMAC.containsKey(rList[0] + "-" + rList[5])) {
							MAC = Constant.pointMAC.get(rList[0] + "-" + rList[5]);
							LogUtil.info("MAC:" + (rList[0] + "-" + rList[5]) + " " + rList[1] + "-->" + MAC);
						}
						HBaseUtil.InsertPointCommunicationLog(Constant.agent, Constant.BuildingDB.get(rList[0]),
								rList[0], this.ip, MAC, rList[5], (rList[6]), "down", "senddownsetack", rList[4],
								Constant.format(new Date()), "processing:finish:" + rList[7]);

						// LogUtil.info("id: " + id);
						// LogUtil.info("InsertPointCommunicationLog" + "
						// begin");

						// if
						// (!Constant.id2status.get(id).contains("finish:finish"))
						// {
						// if ("success".equalsIgnoreCase(rList[7])) {
						// Constant.id2status.put(id, "finish:finish:" +
						// rList[7]);
						// } else {

						// }
						// }

						// LogUtil.info("InsertPointCommunicationLog" + "
						// end");

					} else if ("connect".equalsIgnoreCase(rList[2])) {
						sb.append(rList[0] + ";" + rList[1] + ";" + "connectack" + ";" + Constant.format(new Date()));
						// server.AppendToSend(p.address, new Packet(
						// rList[0] + ";" + rList[1] + ";" + "connectack" +
						// ";"
						// + Constant.format(new Date())));
						// LogUtil.info(server.Name() + " AppendToSend:" +
						// p.address + " " + rList[0] + ";" + rList[1]
						// + ";" + "connectack" + ";" + Constant.format(new
						// Date()));
						Constant.ps_NodeStatus.put(rList[0] + "-" + rList[1], System.currentTimeMillis());
						// this.insertCollectorCommunicationLog(rList);

						// 1101070037;1;pointcount;;19317
						int id = Constant.getID();
						server.AppendToSend(p.address,
								new Packet(rList[0] + ";" + rList[1] + ";" + "pointcount" + ";" + "" + ";" + id));
						LogUtil.info(server.Name() + " AppendToSend:" + p.address + " " + rList[0] + ";" + rList[1]
								+ ";" + "pointcount" + ";" + "" + ";" + id);
					} else if ("heart".equalsIgnoreCase(rList[2])) {
						sb.append(rList[0] + ";" + rList[1] + ";" + "heartack" + ";" + Constant.format(new Date()));
						// server.AppendToSend(p.address, new Packet(
						// rList[0] + ";" + rList[1] + ";" + "heartack" +
						// ";" +
						// Constant.format(new Date())));
						// LogUtil.info(server.Name() + " AppendToSend:" +
						// p.address + " " + rList[0] + ";" + rList[1]
						// + ";" + "heartack" + ";" + Constant.format(new
						// Date()));
						Constant.ps_NodeStatus.put(rList[0] + "-" + rList[1], System.currentTimeMillis());
						// this.insertCollectorCommunicationLog(rList);
						if (this.needGetPointList()) {
							int id = Constant.getID();
							server.AppendToSend(p.address,
									new Packet(rList[0] + ";" + rList[1] + ";" + "pointcount" + ";" + "" + ";" + id));
							LogUtil.info(server.Name() + " AppendToSend:" + p.address + " " + rList[0] + ";" + rList[1]
									+ ";" + "pointcount" + ";" + "" + ";" + id);
						}

					} else if ("pointcountack".equalsIgnoreCase(rList[2])) {
						int count = Integer.valueOf(rList[5]);
						int loop = (count / 50) + 1;
						for (int i = 0; i < loop; i++) {
							// 1101070037;1;pointlist;;19317;50;11;2
							int id = Constant.getID();
							server.AppendToSend(p.address, new Packet(rList[0] + ";" + rList[1] + ";" + "pointlist"
									+ ";" + "" + ";" + id + ";" + 50 + ";" + loop + ";" + (i + 1)));
							LogUtil.info(server.Name() + " AppendToSend:" + p.address + " " + rList[0] + ";" + rList[1]
									+ ";" + "pointlist" + ";" + "" + ";" + id + ";" + 50 + ";" + loop + ";" + (i + 1));

						}
					} else if ("pointlistack".equalsIgnoreCase(rList[2])) {
						// 6666666666;1;pointlistack;;4353;50;11;1;50;206007;11021;206007;11014;206007;11015;206007;11025;206007;11024;206007;11011;206007;11023;206007;11022;206007;11013;206007;11012;208002;11011;208002;11013;208002;11024;208002;11023;208002;11015;208002;11012;208002;11022;208002;11014;208002;11025;208002;11021;503001;11012;503001;11021;503001;11022;503001;11015;503001;11011;503001;11025;503001;11014;503001;11023;503001;11013;503001;11024;201004;11022;201004;11025;201004;11013;201004;11011;201004;11015;201004;11023;201004;11024;201004;11021;201004;11012;201004;11014;204001;11021;204001;11023;204001;11011;204001;11025;204001;11022;204001;11012;204001;11015;204001;11013;204001;11014;204001;11024;
						int count = Integer.valueOf(rList[8]);
						String building = rList[0];
						String mac = rList[1];
						Map<String, String> meterList = new HashMap<String, String>();
						for (int i = 0; i < count; i++) {
							meterList.put((rList[9 + 2 * i]), "");
							String meter = rList[9 + 2 * i];
							String funcid = rList[10 + 2 * i];
							String key = building + "-" + mac + "-" + meter + "." + funcid;
							// synchronized (Constant.pointListUp) {
							if (!Constant.ps_PointStatusUp.containsKey(key)) {
								Constant.ps_PointStatusUp.put(key, null);
							}
							// }
							// if (!Constant.pointListDown.containsKey(key))
							// {
							// Constant.pointListDown.put(key, null);
							// }

						}
						this.updateMeterCollectorControl(rList[0], meterList, p.address);
					} else if (rList.length > 6 && "pointread".equalsIgnoreCase(rList[2])) {
						// 1101070037;1;pointread;;123;1001;11
						// String key = rList[0] + "-" + rList[1] + "-" +
						// rList[5] + "." + rList[6];
						// String id = rList[0] + "-" + rList[1] + "-" +
						// rList[4];
						// Constant.id2time.put(key,
						// System.currentTimeMillis());
						// Constant.id2point.put(id, key);
						// Constant.id2function.put(id, "pointread");
						// Constant.id2status.put(id, "processing:rcvd");

						StringBuffer sb1 = new StringBuffer();
						sb1 = this.getCacheData(rList);
						server.AppendToSend(p.address, new Packet(sb1.toString()));
						LogUtil.info(server.Name() + " AppendToSend: " + p.address + " " + sb.toString());
					} else if (rList.length > 6 && "realtimepointdata".equalsIgnoreCase(rList[2])) {
						// String key = rList[0] + "-" + rList[1] + "-" +
						// rList[5] + "." + rList[6];
						// String id = rList[0] + "-" + rList[1] + "-" +
						// rList[4];
						// Constant.id2time.put(key,
						// System.currentTimeMillis());
						// Constant.id2point.put(id, key);
						// Constant.id2function.put(id, "realtimepointdata");
						// Constant.id2status.put(id, "processing:rcvd");

						StringBuffer sb1 = new StringBuffer();
						sb1 = this.getCacheData2(rList);
						server.AppendToSend(p.address, new Packet(sb1.toString()));
						LogUtil.info(server.Name() + " AppendToSend: " + p.address + " " + sb.toString());
					} else if ("getdbpointlist".equalsIgnoreCase(rList[2])) {
						// 1101070037;1;getdbpointlist
						// 1101070037;1;getdbpointlistack;1001;2;0;1
						String building = rList[0];
						for (Entry<String, List<Integer>> mfs : HBaseUtil.GetDBPointList(Constant.agent,
								Constant.BuildingDB.get(building), "dy_pointlist", building).entrySet()) {
							StringBuffer sb1 = new StringBuffer();
							sb1.append(building).append(";").append(rList[1]).append(";").append("getdbpointlistack")
									.append(";").append(mfs.getKey()).append(";").append(mfs.getValue().size());
							for (Integer f : mfs.getValue()) {
								sb1.append(";").append(f);
							}

							server.AppendToSend(p.address, new Packet(sb1.toString()));
							LogUtil.info(server.Name() + " AppendToSend: " + p.address + " " + sb.toString());
						}

					} else if ("updatedbpointlist".equalsIgnoreCase(rList[2])) {
						// 1101070037;1;updatedbpointlist;1001;2;0;Acc;1;Inst
						String building = rList[0];
						String meter = rList[3];
						int count = Integer.valueOf(rList[4]);
						Map<Integer, String> funcidList = new HashMap<Integer, String>();
						for (int i = 0; i < count; i++) {
							funcidList.put(Integer.valueOf(rList[5 + 2 * i]), rList[6 + 2 * i]);
						}
						HBaseUtil.InsertDBPointList(Constant.agent, Constant.BuildingDB.get(building), building, meter,
								funcidList);
					}
				}
				LogUtil.info("CollectThread Challenge Constant.CollectReportList release...");

				if (sb.length() > 0) {
					server.AppendToSend(p.address, new Packet(sb.toString()));
					LogUtil.info(server.Name() + " AppendToSend:" + p.address + " " + sb.toString());
					Constant.collectSend += sb.toString().length();
				}
				// LogUtil.info("handlePacket end...");
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			LogUtil.error("CollectThread.handlePacket.Exception: " + e.toString());
		}
	}

	private boolean needGetPointList() {
		// TODO Auto-generated method stub
		if (System.currentTimeMillis() - this.getPointList > Constant.Millisecond.MINUTE_3) {
			this.getPointList = System.currentTimeMillis();
			return true;
		}
		return false;
	}

	// private void insertCollectorStatus(String[] rList) {
	// // TODO Auto-generated method stub
	// try {
	// HBaseUtil.InsertCollectorStatus(Constant.agent,
	// Constant.BuildingDB.get(rList[0]), rList[0],
	// Constant.getLocalHostLANAddress().getHostAddress(), rList[1], "");
	// } catch (UnknownHostException e) {
	// // TODO Auto-generated catch block
	// e.printStackTrace();
	// } catch (Exception e) {
	// // TODO Auto-generated catch block
	// e.printStackTrace();
	// }
	// }

	// private void insertCollectorCommunicationLog(String[] rList) {
	// // TODO Auto-generated method stub
	// try {
	// HBaseUtil.InsertCollectorCommunicationLog(Constant.agent,
	// Constant.BuildingDB.get(rList[0]), rList[0],
	// this.ip, rList[1], Constant.format(new Date()), rList[2]);
	// } catch (Exception e) {
	// // TODO Auto-generated catch block
	// e.printStackTrace();
	// LogUtil.error("CollectThread.insertCollectorCommunicationLog.Exception: "
	// + e.toString());
	// }
	// }

	private void pushData(String[] rList) {
		// TODO Auto-generated method stub
		// 1101070037;1;report;20010203040506;123;1001;2;11;3.1;12;3.2
		int count = Integer.valueOf(rList[6]);
		String buildingSign = rList[0];
		String mac = rList[1];
		String meterSign = rList[5];
		String receivetime = rList[3];
		String seq = rList[4];
		for (int i = 0; i < count; i++) {
			try {
				if (rList[8 + i * 2].contains("ff")) {
					continue;
				}
				int funcID = Integer.valueOf(rList[7 + i * 2]);
				double data = Double.valueOf(rList[8 + i * 2]);
				// this.handleData(buildingSign, mac, meterSign, funcID,
				// receivetime, data);
				this.handleDataAddtion(buildingSign, mac, meterSign, funcID, receivetime, data, seq, "");
				if (Constant.BuildingAdds.containsKey(buildingSign)) {
					for (String building : Constant.BuildingAdds.get(buildingSign)) {
						// this.handleData(building, mac, meterSign, funcID,
						// receivetime, data);
						this.handleDataAddtion(building, mac, meterSign, funcID, receivetime, data, seq, "");
					}
				}
			} catch (Exception e) {
				// TODO Auto-generated catch block
				LogUtil.error("CollectThread.pushData.Exception: " + e.toString());
			}
		}
	}

	private void pushData2(String[] rList) {
		// TODO Auto-generated method stub
		// 1101070037;1;report;20010203040506;123;1001;2;11;3.1;12;3.2
		int count = Integer.valueOf(rList[6]);
		String buildingSign = rList[0];
		String mac = rList[1];
		String meterSign = rList[5];
		String receivetime = rList[3];
		String seq = rList[4];
		for (int i = 0; i < count; i++) {
			try {
				if (rList[8 + i * 2].contains("ff")) {
					continue;
				}

				int funcID = Integer.valueOf(rList[7 + i * 3]);
				double data = Double.valueOf(rList[8 + i * 3]);
				String addtion = "null".equalsIgnoreCase(rList[9 + i * 3]) ? "" : (rList[9 + i * 3]);
				// HBaseUtil.InsertPointCommunicationLog(Constant.agent,
				// Constant.BuildingDB.get(buildingSign),
				// buildingSign,
				// Constant.getLocalHostLANAddress().getHostAddress(), mac,
				// meterSign + "." + funcID,
				// "reportaddtion", id, Constant.format(new Date()), addtion);
				// this.handleData(buildingSign, mac, meterSign, funcID,
				// receivetime, data);
				this.handleDataAddtion(buildingSign, mac, meterSign, funcID, receivetime, data, seq, addtion);
				if (Constant.BuildingAdds.containsKey(buildingSign)) {
					for (String building : Constant.BuildingAdds.get(buildingSign)) {
						// this.handleData(building, mac, meterSign, funcID,
						// receivetime, data);
						this.handleDataAddtion(building, mac, meterSign, funcID, receivetime, data, seq, addtion);
					}
				}
			} catch (Exception e) {
				// TODO Auto-generated catch block
				LogUtil.error("CollectThread.pushData2.Exception: " + e.toString());
			}
		}
	}

	// private void handleData(String buildingSign, String mac, String
	// meterSign, int funcID, String receivetime,
	// double data) {
	// // TODO Auto-generated method stub
	// try {
	// if (Constant.RecordAddress.get(buildingSign + "-" + meterSign + "-" +
	// funcID) != null) {
	// int address = Constant.RecordAddress.get(buildingSign + "-" + meterSign +
	// "-" + funcID);
	//
	// Constant.RecordList.get(address).receivetime =
	// Constant.parse(receivetime);
	// Constant.RecordList.get(address).data = data;
	// String key = buildingSign + "-" + mac + "-" + meterSign + "." + funcID;
	// Constant.pointListUp.put(key, System.currentTimeMillis());
	// // LogUtil.info((address + 1) + "/" + Constant.RecordList.size()
	// // + " UPDATE "
	// // + Constant.RecordList.get(address).buildingSign + "."
	// // + Constant.RecordList.get(address).meterSign + "." +
	// // Constant.RecordList.get(address).funcID
	// // + ":" +
	// // Constant.format(Constant.RecordList.get(address).receivetime)
	// // + " "
	// // + Constant.RecordList.get(address).data);
	// } else {
	// Record record = new Record();
	// record.buildingSign = buildingSign;
	// record.meterSign = meterSign;
	// record.funcID = funcID;
	// record.receivetime = Constant.parse(receivetime);
	// record.data = data;
	// Constant.RecordAddress.put(buildingSign + "-" + meterSign + "-" + funcID,
	// Constant.RecordList.size());
	// Constant.RecordList.add(record);
	// String key = buildingSign + "-" + mac + "-" + meterSign + "." + funcID;
	// Constant.pointListUp.put(key, System.currentTimeMillis());
	// // LogUtil.info(Constant.RecordList.size() + "/" +
	// // Constant.RecordList.size() + " ADD "
	// // + record.buildingSign + "." + record.meterSign + "." +
	// // record.funcID + ":"
	// // + Constant.format(record.receivetime) + " " + record.data);
	//
	// }
	//
	// } catch (Exception e) {
	// // TODO Auto-generated catch block
	// LogUtil.error("CollectThread.handleData.Exception: " + e.toString());
	// }
	// }

	private void handleDataAddtion(String buildingSign, String mac, String meterSign, int funcID, String receivetime,
			double data, String seq, String addtion) {
		// TODO Auto-generated method stub
		try {
			if (Constant.RecordAddress.get(buildingSign + "-" + meterSign + "-" + funcID) != null) {
				int address = Constant.RecordAddress.get(buildingSign + "-" + meterSign + "-" + funcID);

				Constant.RecordList.get(address).receivetime = Constant.parse(receivetime);
				Constant.RecordList.get(address).data = data;
				Constant.RecordList.get(address).seq = seq;
				// String key = buildingSign + "-" + mac + "-" + meterSign + "."
				// + funcID;
				// synchronized (Constant.pointListUp) {
				// Constant.pointListUp.put(key, System.currentTimeMillis());
				// }
				// LogUtil.info((address + 1) + "/" + Constant.RecordList.size()
				// + " UPDATE "
				// + Constant.RecordList.get(address).buildingSign + "."
				// + Constant.RecordList.get(address).meterSign + "." +
				// Constant.RecordList.get(address).funcID
				// + ":" +
				// Constant.format(Constant.RecordList.get(address).receivetime)
				// + " "
				// + Constant.RecordList.get(address).data);
			} else {
				Record record = new Record();
				record.buildingSign = buildingSign;
				record.meterSign = meterSign;
				record.funcID = funcID;
				record.receivetime = Constant.parse(receivetime);
				record.data = data;
				record.seq = seq;
				record.addtion = addtion;
				Constant.RecordAddress.put(buildingSign + "-" + meterSign + "-" + funcID, Constant.RecordList.size());
				Constant.RecordList.add(record);
				// String key = buildingSign + "-" + mac + "-" + meterSign + "."
				// + funcID;
				// synchronized (Constant.pointListUp) {
				// Constant.pointListUp.put(key, System.currentTimeMillis());
				// }
				// LogUtil.info(Constant.RecordList.size() + "/" +
				// Constant.RecordList.size() + " ADD "
				// + record.buildingSign + "." + record.meterSign + "." +
				// record.funcID + ":"
				// + Constant.format(record.receivetime) + " " + record.data);

			}

		} catch (Exception e) {
			// TODO Auto-generated catch block
			LogUtil.error("CollectThread.handleData.Exception: " + e.toString());
		}
	}

	private void updatePointSet(String[] rList) {
		// TODO Auto-generated method stub
		// 7777777777;1;senddownsetack;20171102152549;123;1001;0;success
		synchronized (Constant.pointSetList) {
			for (int i = 0; i < Constant.pointSetList.size(); i++) {
				PointSet ps = Constant.pointSetList.get(i);
				if (ps.sendTime > 0 && ps.buildingSign.equalsIgnoreCase(rList[0])
						&& ps.ID == Integer.valueOf(rList[4])) {
					Constant.pointSetList.get(i).recTime = System.currentTimeMillis();
					Constant.pointSetList.get(i).status = rList[7];
					break;
				}
			}
		}
	}

	// private void updateMeterCollector(String building, Map<String, String>
	// meterList, String address) {
	// // TODO Auto-generated method stub
	// for (Entry<String, String> meter : meterList.entrySet()) {
	// this.updateMeterCollector(building, meter.getKey(), address);
	// }
	// }

	private void updateMeterCollectorControl(String building, Map<String, String> meterList, String address) {
		// TODO Auto-generated method stub
		for (Entry<String, String> meter : meterList.entrySet()) {
			this.updateMeterCollectorControl(building, meter.getKey(), address);
		}
	}

	private void updateMeterCollector(String building, String meter, String address) {
		// TODO Auto-generated method stub
		try {
			// if (Constant.Meter_Collector.get(meter) != null) {
			// Constant.Meter_Collector.get(meter).PROTOCOL = protocol;
			// Constant.Meter_Collector.get(meter).IP = address.split(":")[0];
			// Constant.Meter_Collector.get(meter).Port =
			// Integer.valueOf(address.split(":")[1]);
			// } else {
			// Collector c = new Collector();
			// c.PROTOCOL = protocol;
			// c.IP = address.split(":")[0];
			// c.Port = Integer.valueOf(address.split(":")[1]);
			// Constant.Meter_Collector.put(meter, c);
			// }
			Constant.Meter_Collector.put(building + "-" + meter, address);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			LogUtil.error("CollectThread.updateMeterCollector.Exception: " + e.toString());
		}
	}

	private void updateMeterCollectorControl(String building, String meter, String address) {
		// TODO Auto-generated method stub
		try {
			// if (Constant.Meter_Collector.get(meter) != null) {
			// Constant.Meter_Collector.get(meter).PROTOCOL = protocol;
			// Constant.Meter_Collector.get(meter).IP = address.split(":")[0];
			// Constant.Meter_Collector.get(meter).Port =
			// Integer.valueOf(address.split(":")[1]);
			// } else {
			// Collector c = new Collector();
			// c.PROTOCOL = protocol;
			// c.IP = address.split(":")[0];
			// c.Port = Integer.valueOf(address.split(":")[1]);
			// Constant.Meter_Collector.put(meter, c);
			// }
			Constant.Meter_Collector_Control.put(building + "-" + meter, address);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			LogUtil.error("CollectThread.updateMeterCollector.Exception: " + e.toString());
		}
	}

	// private boolean needAck(IServerManager server) {
	// // TODO Auto-generated method stub
	// try {
	// if (server.Name().contains("8887")) {
	// return false;
	// }
	// if (Constant.DBConn = false) {
	// return false;
	// }
	// } catch (Exception e) {
	// // TODO Auto-generated catch block
	// LogUtil.error("CollectThread.needAck.Exception: " + e.toString());
	// }
	// return true;
	// }

	private StringBuffer getCacheData(String[] rList) {
		// TODO Auto-generated method stub
		Record record = new Record();
		StringBuffer sb = new StringBuffer();
		if (Constant.RecordAddress.get(rList[0] + "-" + rList[5] + "-" + rList[6]) != null) {
			int address = Constant.RecordAddress.get(rList[0] + "-" + rList[5] + "-" + rList[6]);
			record = Constant.RecordList.get(address);
			// Constant.info("get pointread by address !");
		} else {
			for (Record r : Constant.RecordList) {
				if (rList[0].equalsIgnoreCase(r.buildingSign) && rList[5].equalsIgnoreCase(r.meterSign)
						&& Integer.valueOf(rList[6]) == r.funcID) {
					record = r;
					// Constant.info("get pointread by for circle !");
					break;
				}
			}
		}
		sb.append(rList[0]).append(";").append(rList[1]).append(";").append("pointreadack").append(";")
				.append(Constant.format(record.receivetime)).append(";").append(rList[4]).append(";")
				.append(record.meterSign).append(";").append(record.funcID).append(";").append(record.data).append(";");
		return sb;
	}

	private StringBuffer getCacheData2(String[] rList) {
		// TODO Auto-generated method stub
		Record record = new Record();
		StringBuffer sb = new StringBuffer();
		if (Constant.RecordAddress.get(rList[0] + "-" + rList[5] + "-" + rList[6]) != null) {
			int address = Constant.RecordAddress.get(rList[0] + "-" + rList[5] + "-" + rList[6]);
			record = Constant.RecordList.get(address);
			// Constant.info("get pointread by address !");
		} else {
			for (Record r : Constant.RecordList) {
				if (rList[0].equalsIgnoreCase(r.buildingSign) && rList[5].equalsIgnoreCase(r.meterSign)
						&& Integer.valueOf(rList[6]) == r.funcID) {
					record = r;
					// Constant.info("get pointread by for circle !");
					break;
				}
			}
		}
		sb.append(rList[0]).append(";").append(rList[1]).append(";").append("realtimepointdataack").append(";")
				.append(Constant.format(record.receivetime)).append(";").append(rList[4]).append(";")
				.append(record.meterSign).append(";").append(record.funcID).append(";").append(record.data).append(";");
		return sb;
	}
	// private boolean needHandle(Date receivetime) {
	// // TODO Auto-generated method stub
	// try {
	// if (receivetime.getSeconds() % this.collectInterval < 5) {
	// return true;
	// }
	// } catch (Exception e) {
	// // TODO Auto-generated catch block
	// e.printStackTrace();
	// }
	// return false;
	// }
}